"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useObserver = void 0;
var react_1 = __importDefault(require("react"));
var reactive_1 = require("@formily/reactive");
var shared_1 = require("../shared");
var useForceUpdate_1 = require("./useForceUpdate");
var AutoCollector = (function () {
    function AutoCollector() {
    }
    return AutoCollector;
}());
var useObserver = function (view, options) {
    var forceUpdate = useForceUpdate_1.useForceUpdate();
    var unmountRef = react_1.default.useRef(false);
    var gcRef = react_1.default.useRef();
    var tracker = react_1.default.useMemo(function () {
        return new reactive_1.Tracker(function () {
            if (typeof (options === null || options === void 0 ? void 0 : options.scheduler) === 'function') {
                options.scheduler(forceUpdate);
            }
            else {
                forceUpdate();
            }
        }, options === null || options === void 0 ? void 0 : options.displayName);
    }, []);
    if (!gcRef.current) {
        gcRef.current = new shared_1.GarbageCollector(function () {
            if (tracker) {
                tracker.dispose();
            }
        });
        gcRef.current.open(new AutoCollector());
    }
    react_1.default.useEffect(function () {
        unmountRef.current = false;
        gcRef.current.close();
        return function () {
            unmountRef.current = true;
            if (tracker) {
                tracker.dispose();
            }
        };
    }, []);
    return tracker.track(view);
};
exports.useObserver = useObserver;
